﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CSVReader
{
	private char lineSeperater = '\n'; // It defines line seperate character
	private char fieldSeperator = '|'; // It defines field seperate chracter

	public CSVReader () {
	}

	public CSVReader(char fieldSep) {
		fieldSeperator = fieldSep;
	}

	public CSVReader( char fieldSep, char lineSep) {
		lineSeperater = lineSep;
		fieldSeperator = fieldSep;
	}

	public List<List<string>> parseCSV(string csvAsset)
	{
		return parseCSV (Resources.Load<TextAsset>(csvAsset));
	}

	// Read data from CSV file
	public List<List<string>> parseCSV(TextAsset csvFile)
	{
		List<List<string>> csvResult = new List<List<string>> ();
		string[] records = csvFile.text.Split (lineSeperater);
		foreach (string record in records) {
			string[] fields = record.Split(fieldSeperator);
			if (fields[0].Equals("\"id\"")) continue;
			List<string> row = new List<string> ();
			foreach (string field in fields) {
				row.Add (field.Replace("\"", ""));
			}
			csvResult.Add (row);
		}
		return csvResult;
	}
}