﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class DeltaGuiFb : MonoBehaviour {

	const float fullDuration = .7f;
	const float initFontSize = 12f;
	const float endFontSize = 18f;

	private float value;
	private float duration = fullDuration;
	private float percentage = 0.0f;
	private GUIStyle style = null;
	private Transform t;
	private Vector2 startPos;
	private Vector2 endPos;
	private Color baseCol;

	public void ParametrizedStart (float value) {
		baseCol = value > 0 ? Color.green : Color.red;
		this.value = value;
		style = new GUIStyle ();
		style.fontStyle = FontStyle.BoldAndItalic;
		t = gameObject.GetComponent<Transform> ();
		startPos = Camera.main.WorldToScreenPoint(t.localPosition);
		endPos = startPos - new Vector2 (15f, -35f);
	}
	
	// Update is called once per frame
	void Update () {
		duration -= Time.deltaTime;
		if (duration <= 0.0f) {
			Object.Destroy (this);
			return;
		}
		percentage = 1.0f - duration / fullDuration;
	}

	void OnGUI() 
	{
		style.fontSize = Mathf.RoundToInt(Mathf.Lerp(initFontSize, endFontSize, percentage));
		style.normal.textColor = new Color (baseCol.r, baseCol.g, baseCol.b, 1.0f - percentage);
		Vector2 delta = Vector2.Lerp(startPos, endPos, percentage);
		GUI.Label (new Rect(
			delta.x, Screen.height - delta.y,
			30, 30
		), value < 0 ? "-" + value : "" + value, style);
	}
}
