﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MouseListener : MonoBehaviour {

	const int Flyer = 0;
	const int Twitter = 1;
	const int Lobbyist = 2;

	float pushBase = .02f;
	float paperLifetime = .75f;
	float fireCooldown = 1f;
	float nextFire = 0;

    public GameObject flyer_Prefab;
	public GameObject tweet_Prefab;

	CSVReader reader;

    GameObject objPrefab;
    public GameObject PlayerHUD;
	Populism.GameManager manager;
	List<GameObject> papers;

	// Use this for initialization
	void Start () {

		//PlayerHUD = GameObject.Find("PlayerHUD");

		manager = GameObject.Find("GameManager").gameObject.GetComponent<Populism.GameManager>();
		//csvValues[Twitter] = reader.parseCSV ("Config/Tweets");
		//csvValues[VectorTypes.Lobbyist] = reader.parseCSV ("Config/Lobbyist");
		papers = new List<GameObject> ();
	}

//	public void changeLevel()
//	{
//		PlayerHUD = GameObject.Find("PlayerHUD");
//	}



	// Update is called once per frame
	void Update () {
		paperLifetime -= Time.deltaTime;
		if (paperLifetime <= 0.0f && papers.Count > 0) {
			foreach (GameObject go in papers) {
				Destroy (go);
			}
			papers.RemoveAll (p => true);
		}
		if (papers.Count > 0) {
			foreach (GameObject go in papers) {
				Color old = go.GetComponent<Renderer> ().material.color;
				old.a = paperLifetime / .75f;
				go.GetComponent<Renderer> ().material.SetColor ("_Color", old);
			}
		}

		if (Input.GetButtonDown("Fire1") && Time.time> nextFire)
		{
			
			nextFire = Time.time + fireCooldown;

            Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);

			int selectedPropaganda = PlayerHUD.GetComponent<PlayerHUD> ().selectedPropaganda;
			Debug.Log ("Selected Prop " + selectedPropaganda);

			// TODO GENERATE PROPAGANDA INSTANCE FROM INDEX AND CSV

			// Parse Propaganda

			List<string> pValues = manager.getPropagandaValues (selectedPropaganda);
			Debug.Log(string.Join(";", pValues.ToArray()));
			Propaganda propaganda = new Propaganda (
				                        float.Parse (pValues [0]), 
				                        float.Parse (pValues [1]), 
				                        float.Parse (pValues [2]), 
				                        float.Parse (pValues [3]), 
				                        float.Parse (pValues [4]));


			if (PlayerHUD.GetComponent<PlayerHUD>().selectedVector == vectors.flyers)
            {
				manager.playSound (0);
				paperLifetime = .75f;
				papers = new List<GameObject> ();
				GameObject objPrefab = Resources.Load<GameObject> ("paper-anim");
				for (int i = 0; i < 20; i++) {
					GameObject pap = Instantiate(objPrefab, ray.origin, Quaternion.identity);
					pap.GetComponent<Rigidbody2D>().AddForce(new Vector2((Random.value - 0.5f) * pushBase, (Random.value - 0.5f) * pushBase));
					Animator anim = pap.GetComponent<Animator> ();
					anim.Play(anim.GetCurrentAnimatorStateInfo(0).shortNameHash, 0, Random.value);
					papers.Add (pap);
				}
				GameObject explosion = Instantiate(flyer_Prefab, ray.origin, Quaternion.identity);
				explosion.GetComponent<Flyer_Explosion> ().propaganda = propaganda;
            }

			if (PlayerHUD.GetComponent<PlayerHUD>().selectedVector == vectors.tweet)
			{
				manager.playSound (1);
				GameObject tweet1 = Instantiate(tweet_Prefab, ray.origin, Quaternion.identity);
				GameObject tweet2 = Instantiate(tweet_Prefab, ray.origin, Quaternion.identity);
				GameObject tweet3 = Instantiate(tweet_Prefab, ray.origin, Quaternion.identity);
				GameObject tweet4 = Instantiate(tweet_Prefab, ray.origin, Quaternion.identity);

				tweet1.GetComponent<SpriteRenderer>().flipX = true;
				tweet4.GetComponent<SpriteRenderer>().flipX = true;

				foreach (GameObject tweet in new GameObject[]{tweet1, tweet2, tweet3, tweet4}) 
					tweet.GetComponent<Flyer_Explosion> ().propaganda = propaganda;
				tweet1.GetComponent<Rigidbody2D> ().velocity = new Vector2 (-3, 3);
				tweet2.GetComponent<Rigidbody2D> ().velocity = new Vector2 (3, 3);
				tweet3.GetComponent<Rigidbody2D> ().velocity = new Vector2 (3, -3);
				tweet4.GetComponent<Rigidbody2D> ().velocity = new Vector2 (-3, -3);


				// CHOOSE HERE WHICH PROPAGANDA WILL BE USED TO AFFECT ENTITIES
				// explosion.GetComponent<Flyer_Explosion>().propaganda = ;
			}

			if (PlayerHUD.GetComponent<PlayerHUD>().selectedVector == vectors.lobbyist)
			{
				manager.playSound (2);
				GameObject objPrefab = Resources.Load<GameObject> ("walking_man");
				GameObject go = Instantiate (objPrefab, ray.origin, Quaternion.identity);
				go.GetComponent<playerController>().ParametrizedStart(Shader.Find("Custom/WhiteJacketShader"), propaganda);
				go.GetComponent<playerController> ().delta = 25.0f; // VERY HIGH!
				// CHOOSE HERE WHICH PROPAGANDA WILL BE USED TO AFFECT ENTITIES
				// explosion.GetComponent<Flyer_Explosion>().propaganda = ;
			}
				
			
			if (Input.GetKey(KeyCode.LeftShift)) {
				// objPrefab = Resources.Load<GameObject> ("explosion");
				// Instantiate (objPrefab, ray.origin, Quaternion.identity);
				// objPrefab = Resources.Load<GameObject> ("walking_man");
				// GameObject go = Instantiate (objPrefab, ray.origin, Quaternion.identity);
				// go.SendMessage("ParametrizedStart", "rich");
			}
		}
	}
}
