﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MouseListener : MonoBehaviour {

	const int Flyer = 0;
	const int Twitter = 1;
	const int Lobbyist = 2;

	float fireCooldown = 1f;
	float nextFire = 0;

    public GameObject flyer_Prefab;
	CSVReader reader;
	List<List<string>>[] csvValues;

    GameObject objPrefab;
    public GameObject PlayerHUD;
	Populism.GameManager manager;

	// Use this for initialization
	void Start () {

		//PlayerHUD = GameObject.Find("PlayerHUD");

		manager = GameObject.Find("GameManager").gameObject.GetComponent<Populism.GameManager>();
		reader = new CSVReader ();
		csvValues = new List<List<string>>[3];
		csvValues[Flyer] = reader.parseCSV ("Config/Flyer");
		csvValues[Twitter] = reader.parseCSV ("Config/Tweets");
		//csvValues[VectorTypes.Lobbyist] = reader.parseCSV ("Config/Lobbyist");
	}

	public void changeLevel()
	{
		PlayerHUD = GameObject.Find("PlayerHUD");
	}


	public List<string> getPropagandaValues(int type, int idx)
	{
		int rowId = 6 * (manager.currentLevel - 1) + idx;
		foreach (List<string> row in csvValues[type]) {
			if (row [0].Equals ("" + rowId)) {
				row.RemoveRange (0, 2);
				return row;
			}
		}
		return null;
	}

	// Update is called once per frame
	void Update () {

		if (Input.GetButtonDown("Fire1") && Time.time> nextFire)
		{
			
			nextFire = Time.time + fireCooldown;

            Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);

			int selectedPropaganda = PlayerHUD.GetComponent<PlayerHUD> ().selectedPropaganda;
			Debug.Log ("Selected Prop " + selectedPropaganda);

			// TODO GENERATE PROPAGANDA INSTANCE FROM INDEX AND CSV

			if (PlayerHUD.GetComponent<PlayerHUD>().selectedVector == vectors.flyers)
            {
                GameObject explosion = Instantiate(flyer_Prefab, ray.origin, Quaternion.identity);
                //CircleCollider2D collider = explosion.GetComponent<CircleCollider2D>();

				List<string> pValues = getPropagandaValues (Flyer, selectedPropaganda);
				explosion.GetComponent<Flyer_Explosion>().propaganda = new Propaganda(
					float.Parse(pValues[0]), 
					float.Parse(pValues[1]), 
					float.Parse(pValues[2]), 
					float.Parse(pValues[3]), 
					float.Parse(pValues[4])
				);
            }

			if (PlayerHUD.GetComponent<PlayerHUD>().selectedVector == vectors.tweet)
			{
				

				// CHOOSE HERE WHICH PROPAGANDA WILL BE USED TO AFFECT ENTITIES
				// explosion.GetComponent<Flyer_Explosion>().propaganda = ;
			}

			if (PlayerHUD.GetComponent<PlayerHUD>().selectedVector == vectors.lobbyist)
			{


				// CHOOSE HERE WHICH PROPAGANDA WILL BE USED TO AFFECT ENTITIES
				// explosion.GetComponent<Flyer_Explosion>().propaganda = ;
			}
				
			
			if (Input.GetKey(KeyCode.LeftShift)) {
				// objPrefab = Resources.Load<GameObject> ("explosion");
				// Instantiate (objPrefab, ray.origin, Quaternion.identity);
				// objPrefab = Resources.Load<GameObject> ("walking_man");
				// GameObject go = Instantiate (objPrefab, ray.origin, Quaternion.identity);
				// go.SendMessage("ParametrizedStart", "rich");
			}
		}
	}
}
