﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Flyer_Explosion : MonoBehaviour {

	//CircleCollider2D collider;

	float lifetime = .5f;
	float pushBase = .02f;

	public Propaganda propaganda;
	List<GameObject> papers;

	void OnTriggerEnter2D(Collider2D other)
	{
		Debug.Log ("Collision detected");
		GameObject collisionEntity = other.gameObject;

		if (collisionEntity.tag == "Entity") {
			collisionEntity.GetComponent<playerController> ().encounterPropaganda (propaganda);
		}
	}



	// Use this for initialization
	void Start () {
		papers = new List<GameObject> ();
		GameObject objPrefab = Resources.Load<GameObject> ("paper-anim");
		for (int i = 0; i < 15; i++) {
			GameObject pap = Instantiate(objPrefab, gameObject.GetComponent<Transform>().position, Quaternion.AngleAxis(Random.value * 360.0f, Vector3.forward));
			pap.GetComponent<Transform>().localScale = pap.GetComponent<Transform>().localScale * .3f;
			pap.GetComponent<Rigidbody2D>().AddForce(new Vector2((Random.value - 0.5f) * pushBase, (Random.value - 0.5f) * pushBase));
			papers.Add (pap);
		}
	}
	
	// Update is called once per frame
	void Update () {
		lifetime -= Time.deltaTime;


		if(lifetime <= 0.0f) {
			foreach (GameObject go in papers) {
				Destroy (go);
			}
			Destroy (gameObject);
		}
	}
}
