﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public enum vectors {flyers, tweet, lobbyist }

public class PlayerHUD : MonoBehaviour {

    
	private Populism.GameManager mgr;
    public vectors selectedVector = 0;
    public int selectedPropaganda = 1;


    public void SelectVector_Flyers()
    {
        ResetVectorColors();

        transform.Find("Panel_Bottom/Vectors/Selected/Button_Flyers_Selected").gameObject.SetActive(true);
        transform.Find("Panel_Bottom/Vectors/Deselected/Button_Flyers_Deselected").gameObject.SetActive(false);

        selectedVector = vectors.flyers;
    }

    public void SelectVector_Tweet()
    {
        ResetVectorColors();

        transform.Find("Panel_Bottom/Vectors/Selected/Button_Tweet_Selected").gameObject.SetActive(true);
        transform.Find("Panel_Bottom/Vectors/Deselected/Button_Tweet_Deselected").gameObject.SetActive(false);

        selectedVector = vectors.tweet;
    }

    public void SelectVector_Lobbyist()
    {
        ResetVectorColors();

        transform.Find("Panel_Bottom/Vectors/Selected/Button_Lobbyist_Selected").gameObject.SetActive(true);
        transform.Find("Panel_Bottom/Vectors/Deselected/Button_Lobbyist_Deselected").gameObject.SetActive(false);

        selectedVector = vectors.lobbyist;
    }

    public void Select_Propaganda_1()
    {
        ResetPropagandaColors();

        transform.Find("Panel_Bottom/Propaganda_Messages/Selected/Button_Propaganda_1").gameObject.SetActive(true);
        transform.Find("Panel_Bottom/Propaganda_Messages/Deselected/Button_Propaganda_1").gameObject.SetActive(false);

        selectedPropaganda = 1;
    }

    public void Select_Propaganda_2()
    {
        ResetPropagandaColors();

        transform.Find("Panel_Bottom/Propaganda_Messages/Selected/Button_Propaganda_2").gameObject.SetActive(true);
        transform.Find("Panel_Bottom/Propaganda_Messages/Deselected/Button_Propaganda_2").gameObject.SetActive(false);

        selectedPropaganda = 2;
    }

    public void Select_Propaganda_3()
    {
        ResetPropagandaColors();

        transform.Find("Panel_Bottom/Propaganda_Messages/Selected/Button_Propaganda_3").gameObject.SetActive(true);
        transform.Find("Panel_Bottom/Propaganda_Messages/Deselected/Button_Propaganda_3").gameObject.SetActive(false);

        selectedPropaganda = 3;
    }

    public void Select_Propaganda_4()
    {
        ResetPropagandaColors();

        transform.Find("Panel_Bottom/Propaganda_Messages/Selected/Button_Propaganda_4").gameObject.SetActive(true);
        transform.Find("Panel_Bottom/Propaganda_Messages/Deselected/Button_Propaganda_4").gameObject.SetActive(false);

        selectedPropaganda = 4;
    }

    public void Select_Propaganda_5()
    {
        ResetPropagandaColors();

        transform.Find("Panel_Bottom/Propaganda_Messages/Selected/Button_Propaganda_5").gameObject.SetActive(true);
        transform.Find("Panel_Bottom/Propaganda_Messages/Deselected/Button_Propaganda_5").gameObject.SetActive(false);

        selectedPropaganda = 5;
    }

    public void Select_Propaganda_6()
    {
        ResetPropagandaColors();

        transform.Find("Panel_Bottom/Propaganda_Messages/Selected/Button_Propaganda_6").gameObject.SetActive(true);
        transform.Find("Panel_Bottom/Propaganda_Messages/Deselected/Button_Propaganda_6").gameObject.SetActive(false);

        selectedPropaganda = 6;
    }


    public void ResetVectorColors()
    {
        transform.Find("Panel_Bottom/Vectors/Selected/Button_Flyers_Selected").gameObject.SetActive(false);
        transform.Find("Panel_Bottom/Vectors/Selected/Button_Tweet_Selected").gameObject.SetActive(false);
        transform.Find("Panel_Bottom/Vectors/Selected/Button_Lobbyist_Selected").gameObject.SetActive(false);

        transform.Find("Panel_Bottom/Vectors/Deselected/Button_Flyers_Deselected").gameObject.SetActive(true);
        transform.Find("Panel_Bottom/Vectors/Deselected/Button_Tweet_Deselected").gameObject.SetActive(true);
        transform.Find("Panel_Bottom/Vectors/Deselected/Button_Lobbyist_Deselected").gameObject.SetActive(true);
    }

    public void ResetPropagandaColors()
    {
        transform.Find("Panel_Bottom/Propaganda_Messages/Selected/Button_Propaganda_1").gameObject.SetActive(false);
        transform.Find("Panel_Bottom/Propaganda_Messages/Selected/Button_Propaganda_2").gameObject.SetActive(false);
        transform.Find("Panel_Bottom/Propaganda_Messages/Selected/Button_Propaganda_3").gameObject.SetActive(false);
        transform.Find("Panel_Bottom/Propaganda_Messages/Selected/Button_Propaganda_4").gameObject.SetActive(false);
        transform.Find("Panel_Bottom/Propaganda_Messages/Selected/Button_Propaganda_5").gameObject.SetActive(false);
        transform.Find("Panel_Bottom/Propaganda_Messages/Selected/Button_Propaganda_6").gameObject.SetActive(false);


        transform.Find("Panel_Bottom/Propaganda_Messages/Deselected/Button_Propaganda_1").gameObject.SetActive(true);
        transform.Find("Panel_Bottom/Propaganda_Messages/Deselected/Button_Propaganda_2").gameObject.SetActive(true);
        transform.Find("Panel_Bottom/Propaganda_Messages/Deselected/Button_Propaganda_3").gameObject.SetActive(true);
        transform.Find("Panel_Bottom/Propaganda_Messages/Deselected/Button_Propaganda_4").gameObject.SetActive(true);
        transform.Find("Panel_Bottom/Propaganda_Messages/Deselected/Button_Propaganda_5").gameObject.SetActive(true);
        transform.Find("Panel_Bottom/Propaganda_Messages/Deselected/Button_Propaganda_6").gameObject.SetActive(true);
    }


	public void ResetPropagandaTexts(List<string> texts)
	{
		transform.Find ("Panel_Bottom/Propaganda_Messages/Selected/Button_Propaganda_1/Text").GetComponent<Text>().text = texts[0];
		transform.Find ("Panel_Bottom/Propaganda_Messages/Selected/Button_Propaganda_2/Text").GetComponent<Text>().text = texts[1];
		transform.Find ("Panel_Bottom/Propaganda_Messages/Selected/Button_Propaganda_3/Text").GetComponent<Text>().text = texts[2];
		transform.Find ("Panel_Bottom/Propaganda_Messages/Selected/Button_Propaganda_4/Text").GetComponent<Text>().text = texts[3];
		transform.Find ("Panel_Bottom/Propaganda_Messages/Selected/Button_Propaganda_5/Text").GetComponent<Text>().text = texts[4];
		transform.Find ("Panel_Bottom/Propaganda_Messages/Selected/Button_Propaganda_6/Text").GetComponent<Text>().text = texts[5];
		transform.Find ("Panel_Bottom/Propaganda_Messages/Deselected/Button_Propaganda_1/Text").GetComponent<Text>().text = texts[0];
		transform.Find ("Panel_Bottom/Propaganda_Messages/Deselected/Button_Propaganda_2/Text").GetComponent<Text>().text = texts[1];
		transform.Find ("Panel_Bottom/Propaganda_Messages/Deselected/Button_Propaganda_3/Text").GetComponent<Text>().text = texts[2];
		transform.Find ("Panel_Bottom/Propaganda_Messages/Deselected/Button_Propaganda_4/Text").GetComponent<Text>().text = texts[3];
		transform.Find ("Panel_Bottom/Propaganda_Messages/Deselected/Button_Propaganda_5/Text").GetComponent<Text>().text = texts[4];
		transform.Find ("Panel_Bottom/Propaganda_Messages/Deselected/Button_Propaganda_6/Text").GetComponent<Text>().text = texts[5];
	}

    // Use this for initialization
	void Start () {
		mgr = GameObject.Find("GameManager").gameObject.GetComponent<Populism.GameManager>();
		Debug.Log(string.Join(", ", mgr.getPropagandaStrings ().ToArray()));
		ResetPropagandaTexts(mgr.getPropagandaStrings ());
        SelectVector_Flyers();
        Select_Propaganda_1();


    }
	
	// Update is called once per frame
	void Update () {
		
	}
}
